
;*************************************************************************
;* Actually Draws the Screen                                             *
;*************************************************************************

LoadTileMap:
	call rotatetiles
	ld hl, (mappos)													;hl=mappos, de=playerpos, hl=hl+de, tempword1=hl
	ld de, (playerpos)
	add hl, de
	ld de, $1000
	sbc hl, de
	ld (tempword1), hl
	ld a, 8  																;loop y variable
LTMloop1:
	ld (tempvar1), a
	ld a, 16																;loop x variable
LTMloop2:
	ld (tempvar2), a													
	ld hl, (tempword1)												;load pointer
	ld a, (hl)															;load byte from map into a
	inc hl
	ld (tempword1), hl
	call LTMdrawit														;we got a, go draw it
	ld a, (tempvar2)													;decrement a, if it's not 0 then go do the next loop
	dec a
	jp nz, LTMloop2
	ld hl, (curmapwidth)
	ld de, 16
	sbc hl, de
	ex de, hl
	ld hl, (tempword1)
	add hl, de
	ld (tempword1), hl												;load it back into the pointer
	ld a, (tempvar1)
	dec a
	ret z
	jp LTMloop1

LTMdrawit:
	call checkunder
	call checkover
	ld (tempblock), a
	cp 102
	call nc, characterLTM
	ld l, a
	ld h, 0
	add hl, hl
	add hl, hl
	add hl, hl
	add hl, hl
	ld de, bricks
	add hl, de
	ld a, (tempvar1)												;d=y pos
	ld b, a
	ld a, 8
	sub b
	ld d, a
	ld a, (tempvar2)												;e=x pos (based on loop variable)
	ld b, a
	ld a, 16
	sub b
	ld e, a
	push de																;push variables into stack for later use
	ld a, (tempvar1)
	cp 5
	call z, LTMotherstuff
	ld a, (tempvar2)
	cp 8
	call z, LTMotherstuff2
	ld a, (monster1)
	cp 3
	call nc, dungeonblack
	pop de
	jp GridPutSprite

checkunder:
	ld c, a
	ld hl, (tempword1)
	ld de, (mappos)
	call hlde
	cp 1
	jr nz, xora
	ld a, c
	ret
checkover
	ld c, a
	ld hl, (mappos)
	ld de, (mapsize)
	add hl, de
	ld de, (tempword1)
	call hlde
	cp 1
	jr nz, xora
	ld a, c
	ret
xora:
	ld a, (monster2)
	ret

;*************************************************************************
;* Black Dungeon Background                                              *
;*************************************************************************

rotatetiles
	ld hl, water
	ld b, 4
rwaterloop
	ld a, (hl)
	rlc a
	ld (hl), a
	inc hl
	djnz rwaterloop
	ld b, 4
rwaterloop2
	ld a, (hl)
	rrc a
	ld (hl), a
	inc hl
	djnz rwaterloop2
	ld hl, waterfall+9
	ld b, 5
	ld a, (waterfall+14)
waterfallloop:
	inc hl
	ld c, (hl)
	ld (hl), a
	ld a, c
	djnz waterfallloop
	ld hl, portal1
	ld de, portal2
	call iconexchange
	ld hl, torch1
	ld de, torch2
	call iconexchange
	ld a, (walkvar)
	cp 1
	ret z
	ld hl, bricks
	ld de, grass2
	call iconexchange
	ret

iconexchange:
	ld b, 16
iconexchangeloop:
	ld a, (hl)
	ex de, hl
	ld c, (hl)
	ld (hl), a
	ex de, hl
	ld (hl), c
	inc de
	inc hl
	djnz iconexchangeloop
	ret

dungeonblack:
	ld a, (radiance)
	cp 8
	ret z
	ld c, a
	ld a, 8
	sub c
	ld b, a
	ld a, (tempvar2)
	cp b
	jr c, makeblack
	ld a, 8
	add a, c
	ld b, a
	ld a, (tempvar2)
	cp b
	jr z, db1
	jr nc, makeblack
db1:
	ld a, 5
	sub c
	ld b, a
	ld a, (tempvar1)
	cp b
	jr c, makeblack
	ld a, 5
	add a, c
	ld b, a
	ld a, (tempvar1)
	cp b
	ret z
	jr nc, makeblack
	ret
makeblack:
	ld hl, blackback
	ret
blackback:
	.db 255, 255, 255, 255, 255, 255, 255, 255
	.db 255, 255, 255, 255, 255, 255, 255, 255
	
;*************************************************************************
;* People Stuff                                                          *
;*************************************************************************

characterLTM:
	call gocharstart
	inc hl
	inc hl
	ld b, (hl)
	ld a, (walkvar)
	add a, b
	ret

;*************************************************************************
;* Loads Surrounding Info                                                *
;*************************************************************************

LTMotherstuff2:
	ld a, (tempvar1)
	cp 4
	jp z, loaddown
	cp 6
	jp z, loadup
	ret

LTMotherstuff:
	ld a, (tempvar2)
	cp 8
	jp z, loadsame
	cp 7
	jp z, loadright
	cp 9
	jp z, loadleft
	ret

loadright:
	ld a, (tempblock)
	ld (rightblock), a
	ret

loadleft:
	ld a, (tempblock)
	ld (leftblock), a
	ret

loadup:
	ld a, (tempblock)
	ld (upblock), a
	ret

loaddown:
	ld a, (tempblock)
	ld (downblock), a
	ret

loadsame
	ld a, (tempblock)
	ld (sameblock), a
	cp 61
	jr z, comeback
	cp 100
	jr z, closedoor
	cp 101
	jr z, closedoor
	cp 56
	ret nc
	cp 52
	jr z, openthedoor
	cp 53
	jr z, openthedoor
comeback:
	ld a, (walkvar)
	add a, a
	add a, a
	add a, a
	add a, a
	ld e, a
	ld d, 0
	ld hl, (dirword)
	add hl, de
	ret
closedoor:
	sub 48
doorchange:
	ld (sameblock), a
	ld hl, (tempword1)
	dec hl
	ld (hl), a
	jr comeback
openthedoor:
	add a, 48
	jr doorchange

.end