;**************************************************************
;* Menu (Item + Status)
;**************************************************************

drawmenu:
	call ClearScreen
	ld bc, $0007
	ld de, $0006
	call makewindow
	ld hl, name
	ld de, $0203
	call drawstring
	ld hl, lvstring
	ld de, $021E
	call drawstring
	ld hl, (level)
	ld bc, $0227
	call drawnumber
	ld hl, hpstring
	ld de, $0803
	call drawstring
	ld hl, (hp)
	ld bc, $080D
	call drawnumber
	ld hl, slash
	ld de, $0821
	call drawstring
	ld hl, (maxhp)
	ld bc, $0825
	call drawnumber
	ld hl, weaponstring
	ld de, $0e03
	call drawstring
	ld a, (weapon)
	ld de, $0e13
	call drawitem
	ld hl, armorstring
	ld de, $1403
	call drawstring
	ld a, (armor)
	ld de, $1413
	call drawitem
	ld hl, stepsstring
	ld de, $1a03
	call drawstring
	ld a, (relic1)
	ld de, $1a13
	call drawitem
	ld hl, stepsstring
	ld de, $2003
	call drawstring
	ld a, (relic2)
	ld de, $2013
	call drawitem
	ld hl, goldstring
	ld de, $2803
	call drawstring
	ld hl, (gold)
	ld bc, $2817
	call drawnumber
	ld hl, (hours)
	ld bc, $3021
	call drawnumber
	ld hl, colontimer
	ld de, $3035
	call drawstring
	ld hl, (steps)
	ld bc, $302B
	call drawnumber
	ld hl, nextstring
	ld de, $2e03
	call drawstring
	ld hl, (nextlevel)
	ld bc, $2e17
	call drawnumber
	ld bc, $080e
	ld de, $0002
	call makewindow
	ld hl, itemstring
	ld de, $0246
	call drawstring
	ld hl, sortstring
	ld de, $0946
	call drawstring
	ld hl, dropstring
	ld de, $1046
	call drawstring
;	ld hl, (playerpos)				;necessary for finding coordinates. May need it later.
;	ld bc, $2046
;	call drawnumber
	ret

showmenu:
	ld b, a
	ld a, (fighton)
	cp 1
	jr z, fightison
	call drawmenu
	ld bc, $0210
	ld d, 7
	ld a, $43
	call blinkselect
	cp 0
	jr z, useitem
	cp 1
	jr z, sortitems
	cp 2
	jr z, dropitem
fightison
	ld a, b
	ret

slash:
	.db "/", 0

colontimer:
	.db ":0", 0

itemstring:
	.db "Use Item",0
sortstring:
	.db "Sort Items",0
dropstring:
	.db "Drop Item",0

sortitems:
	call Itemselect
	cp 255
	jp z, showmenu
	push hl
	call Itemselect
	cp 255
	jp z, showmenu
	pop de
	ld b, a
	ld a, (de)
	cp b
	jr z, sameitemassimilate
noassimilate:
	ld (hl), a
	ld a, b
	ld (de), a
	inc hl
	inc de
	ld b, (hl)
	ld a, (de)
	ld (hl), a
	ld a, b
	ld (de), a
	jr sortitems
sameitemassimilate:
	inc hl
	inc de
	ld b, (hl)
	ld a, (de)
	add a, b
	cp 100
	jr nc, backtoobig
	ld (hl), a
	xor a
	ld (de), a
	dec de
	ld (de), a
	jp sortitems
backtoobig:
	dec de
	dec hl
	ld b, (hl)
	ld a, (de)
	jr noassimilate

dropitem:
	call Itemselect
	cp 255
	jp z, showmenu
	xor a
	ld (hl), a
	inc hl
	ld (hl), a
	jr dropitem

useitem:
	call Itemselect
	cp 0
	jp z, showmenu
	cp 255
	jp z, showmenu
	cp 20
	jp nc, equiptime
	push hl
	add a, a
	ld l, a
	ld h, 0
	ld de, itemusetable-2
	add hl, de
	ld e, (hl)
	inc hl
	ld d, (hl)
	pop hl
	push de
	ret
itemusetable:
	.dw usebandaid
	.dw usecure1
	.dw usecure2
	.dw usecure3
	.dw useotheritem						;token
	.dw useotheritem						;dart
	.dw useotheritem						;arrow
	.dw useotheritem						;bow
	.dw useotheritem						;shard
	.dw useotheritem						;scroll
	.dw useotheritem						;" "
	.dw useotheritem						;and so on
	.dw useotheritem
	.dw useotheritem
	.dw useotheritem
	.dw useotheritem
	.dw usehazelnut						;hazelnut
	.dw useclaironut
	.dw usecurescroll

usebandaid:
	ld a, r
	and %00001111
	add a, 10
finishcure1:
	ld e, a
	ld d, 0
	call dropthisitem
finishcure2
	ld hl, (hp)
	add hl, de
	ld de, (maxhp)
	call hlde
	cp 1
	jr nz, noresethp
	push de
	pop hl
noresethp:
	ld (hp), hl
	ld a, 1
	jp showmenu

usecure1:
	ld a, r
	and %00111111
	add a, 70
	jr finishcure1

usecure2:
	call dropthisitem
	ld a, r
	ld l, a
	ld h, 0
	add hl, hl
	ld de, 500
	add hl, de
	ex de, hl
	jr finishcure2

usecure3:
	call dropthisitem
	ld a, r
	ld l, a
	ld h, 0
	add hl, hl
	add hl, hl
	ld de, 2000
	add hl, de
	ex de, hl
	jr finishcure2

usehazelnut:
	ld a, (fighton)
	dec a
	ret z
	call dropthisitem
	ld a, 1
	ld (hazelnuton), a
	jp showmenu

useclaironut:
	ld a, (fighton)
	dec a
	ret z
	call dropthisitem
	ld a, 8
	ld (radiance), a
	jp showmenu

usecurescroll:
	call dropthisitem
	ld hl, (maxhp)
	ld (hp), hl
	ld a, 1
	jp showmenu

equiptime:
	push af
	pop bc
	ld a, (fighton)
	dec a
	ret z
	push hl
	push bc
	call dropthisitem
	pop af
	pop hl
	push af
	pop bc
	cp 38
	jr nc, equiparmor
	cp 31
	jr nc, equipweapon
	ld a, (relic2)
	ld c, a
	ld a, (relic1)
	ld d, a
	ld a, b
	ld (relic1), a
	ld a, d
	ld (relic2), a
	ld a, c
	call additem
	jp showmenu
equiparmor:
	ld a, (armor)
	ld c, a
	ld a, b
	ld (armor), a
	ld a, c
	call additem
	jp showmenu
equipweapon:
	ld a, (weapon)
	ld c, a
	ld a, b
	ld (weapon), a
	ld a, c
	call additem
	jp showmenu

useotheritem:
	ld a, (fighton)
	cp 0
	jp z, showmenu
	ld a, 254
	ret
.end
