
;*************************************************************************
;* General Selection Menu                                                *
;*************************************************************************

AIselect:
	call waitkey
	ld a, (sameblock)
	cp 51
	jp z, bossbattlemaybe
	ld hl, (playerpos)					;chest
	ld (cpword), hl
	call cplocation
	ld a, b
	cp 0
	jr z, nochest
	ld a, (hl)
	cp 255
	jr nz, nochest
	inc hl
	inc hl
	push hl
	inc hl
	ld e, (hl)
	ld d, 0
	ld hl, chestinfo
	add hl, de
	pop de
	ld a, (hl)
	cp 1
	jp z, emptychest
	ld a, (de)
	push de
	push af
	ld hl, TChest1
	ld (talkword), hl
	call talkit
	pop af
	cp 45
	jp nc, foundgold
	push af
	call additem
	pop af
	push af
	ld de, $2a30
	call drawitem
	pop af
	cp 9
	jp z, maybemerchantbattle
backfromgold:
	pop hl
bfromgold2:
	inc hl
	ld e, (hl)
	ld d, 0
	ld hl, chestinfo
	add hl, de
	ld a, 1
	ld (hl), a
	call pause
	ret
nochest:
	ld a, (lookdir)						;talk
	ld l, a
	ld h, 0
	ld de, walkvar
	add hl, de
	ld a, (hl)
	cp 70
	jr z, talkbush
	cp 29
	jr z, talkchest
	cp 17
	jr z, talkchest
	cp 95
	jr z, talkwall
	cp 89
	jr z, talkwall
	cp 102
	jr c, notalk
	call gocharstart
	ld e, (hl)
	inc hl
	ld d, (hl)
	ex de, hl
	ld a, h
	cp 255
	jr z, forgetdemon
	push hl
	ld de, TDemon109-1
	call hlde
	cp 1
	jp z, talkintoademon
backfromdemontalk:
	pop hl
forgetdemon:
	jr gsearch4
notalk:
	ld hl, 0
	jr gsearch4
talkbush:
	ld hl, Tbush
	jr gsearch4
talkchest:
	ld hl, Tchest
	jr gsearch4
talkwall:
	ld hl, TWall
	jr gsearch4

gsearch4:
	ld (talkword), hl
	call talkit
	jp pause

emptychest:
	ld hl, TChest2
	jp gsearch4

foundgold:
	ld l, a
	ld h, 0
	ld bc, $2a20
	push hl
	call drawnumber
	pop hl
	ld de, (gold)
	add hl, de
	ld (gold), hl
	ld hl, goldstring2
	ld de, $2a38
	call drawstring
	jp backfromgold

goldstring2:
	.text "gold."

bossbattlemaybe:
	ld a, (monster1)
	ld (bosstemp), a
	cp 0
	ret z
	cp 3
	jr z, bossfirathom
	cp 4
	jr z, bossaquamox
	cp 5
	jr z, bossenergion
bossterragamos:
	ld a, 24
	call checkitem
	cp 1
	ret z
	ld hl, TBossbefore4
	call gsearch4
	ld a, 51
	call finishbosssetup
	ld hl, TScroll4
	call gsearch4
	ld a, 24
	jp additem
finishbosssetup
	pop hl
	ld (tempfightword), hl
	pop hl
	ld (tempfightword2), hl
	ld (monster1), a
	call rloadfight
	ld hl, (tempfightword2)
	push hl
	ld hl, (tempfightword)
	push hl
	ld a, (bosstemp)
	ld (monster1), a
	ret

bossfirathom:
	ld a, 21
	call checkitem
	cp 1
	ret z
	ld hl, TBossbefore1
	call gsearch4
	ld a, 47
	call finishbosssetup
	ld hl, TScroll1
	call gsearch4
	ld a, 21
	jp additem
bossaquamox:
	ld a, 22
	call checkitem
	cp 1
	ret z
	ld hl, TBossbefore2
	call gsearch4
	ld a, 48
	call finishbosssetup
	ld hl, TScroll2
	call gsearch4
	ld a, 22
	jp additem
bossenergion:
	ld a, 23
	call checkitem
	cp 1
	ret z
	ld hl, TBossbefore3
	call gsearch4
	ld a, 49
	call finishbosssetup
	ld hl, TScroll3
	call gsearch4
	ld a, 23
	jp additem

maybemerchantbattle:
	ld a, (monster1)
	cp 0
	jp nz, backfromgold
	pop hl
	call bfromgold2						;emptying the chest is necessary
	ld (bosstemp), a
	ld hl, TBossbefore5
	call gsearch4
	ld a, 50
	ld (monster1), a
	call finishbosssetup				;call and return is necessary because routine messes with stack
	ret
talkintoademon:
	ld a, (relic1)						;if you have plastic horns on, you can talk to 'em
	cp 26
	jp z, backfromdemontalk
	ld a, (relic2)
	cp 26
	jp z, backfromdemontalk
	pop hl
	ld a, (monster1)
	ld (bosstemp), a
	ld hl, TBossbefore6
	call gsearch4
	ld a, 40
	ld (monster1), a
	call finishbosssetup
	ret
bosstemp:
	.db 0
tempfightword:
	.dw 0
tempfightword2:
	.dw 0
;*************************************************************************
;* Talking Routines                                                      *
;*************************************************************************


talkit:
	ld hl, dwtalk
	call loadstring
	ld de, (talkword)
	ld a, d
	cp 255
	jp z, specialtalk
	add hl, de
	push hl
	ld bc, $000f
	ld de, $0507
	call makewindow
	pop hl
	ld de, $2a03
	ld (tempword1), de
	ld a, 1
	ld (scrollcounter), a
	call drawtalk
	jp LoadMap

drawtalk:
	ld a, (hl)
	cp 255
	ret z
	cp 0
	call z, nextline
	ld (tempvar1), a
	push hl
	ld hl, tempvar1
	ld de, (tempword1)
	ld b, 1
	ld (_penCol), de
	call _vputsn
	ld de, (_penCol)
	ld (tempword1), de
	ld a, (keyvar)
	ld b, 15
	cp 6
	call nz, keyloop
	pop hl
	inc hl
	jr drawtalk

nextline:
	ld b, a
	ld a, (tempword1+1)
	add a, 7
	cp 63
	call z, scrollupnextline
	ld (tempword1+1), a
	ld a , 3
	ld (tempword1), a
	ld a, b
	ret

scrollupnextline:
	push hl
	ld a, (scrollcounter)
	dec a
	jr nz, sunlback
	call pause
	ld a, 3
sunlback:
	ld (scrollcounter), a
	ld b, 7
sunl4:
	ld hl, $feb0
	ld de, $fea0
	push bc
	ld bc, 320
	ldir
	ld b, 8
	call keyloop
	pop bc
	djnz sunl4
	ld a, 56
	pop hl
	ret
scrollcounter:
	.db 1

;*************************************************************************
;* Special Talk (Shops, King, etc.)                                      *
;*************************************************************************

specialtalk:
	ld a, e
	cp $04
	jp c, innshop
	cp $0e
	jp nc, otherones
	sub 4
	ld l, a
	ld h, 0
	add hl, hl
	push hl
	add hl, hl
	pop de
	add hl, de
	ld de, shopinfo
	add hl, de
	push hl
	ld hl, TShop1
	ld (talkword), hl
	call talkit
	ld bc, $060f
	ld de, $0005
	call makewindow
	ld hl, goldstring
	ld de, $3843
	call drawstring
	ld hl, (gold)
	ld bc, $3857
	call drawnumber
	pop hl
	ld b, 6
	push hl
shoploop:
	push bc
	push hl
	ld a, (hl)
	ld l, a
	ld h, 0
	ld de, itemprice
	add hl, hl
	add hl, de
	ld e, (hl)
	inc hl
	ld d, (hl)
	ex de, hl
	ld a, 6
	sub b
	push af
	add a, a
	add a, a
	add a, a
	pop bc
	sub b
	add a, 3
	ld b, a
	push bc
	ld c, $6b
	call drawnumber
	pop de
	pop hl
	push hl
	ld a, (hl)
	ld e, $36
	call drawitem
	pop hl
	inc hl
	pop bc
	djnz shoploop
	ld bc, $0326
	ld d, 7
	ld a, $33
	call blinkselect
	pop hl
	cp 255
	jr z, finishshop
	ld e, a
	ld d, 0
	add hl, de
	ld a, (hl)
	push af
	ld l, a
	ld h, 0
	add hl, hl
	ld de, itemprice
	add hl, de
	ld e, (hl)
	inc hl
	ld d, (hl)
	ld hl, (gold)
	call hlde
	cp 0
	jr z, nomoneyshop
	sub 0
	sbc hl, de
	ld (gold), hl
	pop af
	call additem
finishshop:
	ld hl, TShop3
	ld (talkword), hl
	jp talkit
nomoneyshop
	pop hl
	ld hl, TShop2
	ld (talkword), hl
	jp talkit

innshop:
	push af
	ld hl, TShop4
	call inntalk
	pop af
	ld (tempinn), a
	cp $00
	call z, castleprice
	cp 1
	call z, town2price
	cp 2
	call z, town4price
	cp 3
	call z, dtownprice
	push hl
	ld bc, $3110
	call drawnumber
	call yesnowindow
	cp 1
	jr z, finish
	pop de
	ld hl, (gold)
	call hlde
	cp 0
	jr z, nomoneyinn
	sub 0
	sbc hl, de
	ld (gold), hl
	ld hl, (maxhp)
	ld (hp), hl
	ld hl, TShop6
	call inntalk
	ld a, (tempinn)
	cp $00
	call z, bedatcastle
	cp 1
	call z, bedattown2
	cp 2
	call z, bedattown4
	cp 3
	call z, bedatdtown
	ld (playerpos), hl
	ld hl, herospritedown1
	ld (dirword), hl
	ld hl, dwsave						;save game
	ld (findfile), hl
	rst 20h
	rst 10h
	jp c, nofile
	ld a,b
	ex de,hl
	call _ahl_plus_2_pg3
	call _set_abs_dest_addr
	xor a
	ld hl, hp
	call _set_abs_src_addr
	xor a
	ld hl, savesize
	call _set_mm_num_bytes
	call _mm_ldir
	jp LoadMap

inntalk:
	ld (talkword), hl
	jp talkit
finish:
	pop hl
	ret
nomoneyinn:
	ld hl, TShop5
	jr inntalk
castleprice:
	ld hl, 30
	ret
bedatcastle:
	ld hl, $10a2
	ret
town2price:
	ld hl, 100
	ret
bedattown2:
	ld hl, 4461
	ret
town4price:
	ld hl, 250
	ret
bedattown4:
	ld hl, 4166
	ret
dtownprice:
	ld hl, 600
	ret
bedatdtown:
	ld hl, 4101
	ret

tempinn:
	.db 0

otherones:
	cp $0e
	jr z, Richeltalk
	cp $0f
	jr z, Manatscorpioncave
	cp $10
	jr z, Finalbosstalk
	ret

Richeltalk:
	ld a, 9
	call checkitem
	cp 0
	jr z, noshards
	inc hl
	ld a, (hl)
	cp 5
	jr z, gotemall
noshards:
	ld hl, TRichel1
	jp gsearch4
gotemall:
	xor a
	ld (hl), a
	dec hl
	ld (hl), a
	ld hl, TRichel2
	call gsearch4
	ld a, 37
	jp additem

Manatscorpioncave:
	ld d, 0
	ld a, 21
	call checkitem
	cp d
	jr z, notransgo
	ld a, 22
	call checkitem
	cp d
	jr z, notransgo
	ld a, 23
	call checkitem
	cp d
	jr z, notransgo
	ld a, 24
	call checkitem
	cp d
	jr z, notransgo
	ld hl, TScorpion1
	call gsearch4
	ld hl, 0
	ld (curmap), hl
	ld hl, 8214
	ld (playerpos), hl
	jp loadmap
notransgo:
	ld hl, TScorpion2
	jp gsearch4

Finalbosstalk:
	ld hl, TKithagar1
	call gsearch4
	pop hl
	ld (kithtemp), hl
	ld a, 52
	call finishbosssetup
	ld hl, (kithtemp)
	push hl
	ld hl,$1de0
	ld (curmap), hl
	ld hl, 4141
	ld (playerpos), hl
	ld hl, herospriteup1
	ld (dirword), hl
	call loadmap
	call loadtilemap
	ld hl, TKithagar2
	call gsearch4
	call CloseGrey
	jp _jforcecmdnochar			;too lazy to figure out how many calls were nested, and going to the home screen
								;after beating the game seems to have a nice touch.

kithtemp:
	.dw 0
yesnowindow:			;0= yes 1=no
	ld bc, $0204
	ld de, $0102
	call makewindow
	ld hl, yesstring
	ld de, $0a16
	call drawstring
	ld hl, nostring
	ld de, $1016
	call drawstring
	ld bc, $0a10
	ld d, 6
	ld a, $13
	call blinkselect
	ret
yesstring:
	.text "Yes"
Nostring:
	.text "No"
.end