
;*************************************************************************
;* Subroutines                                                           *
;*************************************************************************


checkitem:
	ld b, a
	ld a, (relic1)
	cp b
	jr z, gotthatitem2
	ld a, (relic2)
	cp b
	jr z, gotthatitem2
	ld a, (weapon)
	cp b
	jr z, gotthatitem2
	ld a, (armor)
	cp b
	jr z, gotthatitem2
	ld a, b
	ld hl, items
	ld b, 32
citemloop:
	push bc
	ld b, (hl)
	cp b
	jr z, gotthatitem
	inc hl
	inc hl
	pop bc
	djnz citemloop
	xor a
	ret
gotthatitem:
	pop bc
gotthatitem2:
	ld a, 1
	ret

additem:
	cp 0
	ret z
	ld hl, items
	ld c, a
	ld b, 32
aitemloop:
	ld a, (hl)
	cp c
	jr z, addit
backtocounting:
	inc hl
	inc hl
	djnz aitemloop
	ld hl, items
	ld b, 32
aitemloop2:
	ld a, (hl)	
	cp 0
	jr z, addit
	inc hl
	inc hl
	djnz aitemloop2
	ret
addit:
	ld (hl), c
	inc hl
	ld a, (hl)
	inc a
	cp 100
	jr z, backtocounting
	ld (hl), a
	ret

dropthisitem:
	inc hl
	ld a, (hl)
	cp 0
	jr z, notthere
	dec a
	cp 0
	jr z, notthere
finishdrop:
	ld (hl), a
	ret
notthere:
	ld (hl), a
	dec hl
	jr finishdrop

drawitem:
	ld hl, Itemnames
	inc a
	ld b, a
ditemloop
	push bc
	ld b, 1
	ld a, 0							;"/"
	cpir
	pop bc
	djnz ditemloop
	jp drawstring

GridPutSprite:
    push hl                               
    pop ix               
    srl d                 
    rra                
    and $80                
    or e                  
    ld e,a
    push de     
    ld hl,$fc00           
    add hl,de              
    ld b,8                
    ld de,16              
GPS_Loop:
    ld a,(ix + 0)         
    ld (hl),a            
    inc ix               
    add hl,de           
    djnz GPS_Loop
    ld hl,$ca00
    pop de
    add hl, de
    ld b, 8
    ld de, 16
GPS_Loop2:
    ld a,(ix + 0)         
    ld (hl),a            
    inc ix               
    add hl,de           
    djnz GPS_Loop2          
    ret                   

gocharstart:
	ld hl, (mapsize)
	ld de, (mappos)
	add hl, de
	ld b, (hl)
	inc hl
	push hl
	ld l, b
	ld h, 0
	add hl, hl					;multiply by six
	push hl
	add hl, hl
	pop de
	add hl, de
	pop de
	add hl, de
	sub 102
	ex de, hl
	push de
	ld l, a
	ld h, 0
	add hl, hl
	ld e, a
	ld d, h
	add hl, de
	pop de
	add hl, de
	ret
	
loadstring:
	ld (findfile), hl
	rst 20h
	rst 10h
	jp c, nofile
	ld a,b
	ex de,hl
	call _ahl_plus_2_pg3
	call _set_abs_src_addr
	ld a,1
	ld hl,$0100
	call _set_abs_dest_addr
	xor a
	ld hl,$2E40
	call _set_mm_num_bytes
	call _mm_ldir
	call _ram_page_1
	ld hl, $8100
	ret

ItemSelect:				;draws item selection menu. Returns item number + address
	ld bc, $080f
	ld de, $0007
	call makewindow
	ld hl, lastitemstring
	ld de, $0246
	call drawstring
	ld de, $3846
	call drawstring
	ld hl, (itemoffset)
	add hl, hl
	ld de, items
	add hl, de
	ld b, 8
	ld de, $0846
drawitemloop:
	push bc
	push de
	push hl
	inc hl
	ld a, (hl)
	cp 0
	jr z, nonumber
	cp 1
	jr z, nonumber
	ld l, a
	ld h, 0
	push de
	pop bc
	ld c, $6b
	call drawnumber
nonumber:
	pop hl
	pop de
	push de
	push hl
	ld a, (hl)
	call drawitem
	pop hl
	inc hl
	inc hl
	pop de
	ld a, d
	add a, 6
	ld d, a
	pop bc
	djnz drawitemloop
	ld bc, $0238
	ld d, 6
	ld a, $43
	call blinkselect
	cp 255
	ret z
	cp 0
	jr z, uppage
	cp 9
	jr z, downpage
	dec a
	ld b, a
	ld a, (itemoffset)
	add a, b
	add a, a
	ld l, a
	ld h, 0
	ld de, items
	add hl, de
	ld a, (hl)
	ret
uppage:
	ld a, (itemoffset)
	sub 8
	jr nc, uppagesave				;if you go past 0, start item selection at 24th item on menu (last page)
	ld a, 24
uppagesave:
	ld (itemoffset), a
	jp itemselect
downpage
	ld a, (itemoffset)
	add a, 8
	cp 32
	jr nz, uppagesave				;if you go to 32, a page that doesn't exist, loads offset with 0, the first page
	xor a
	jr uppagesave
lastitemstring:
	.text "Last Page"
nextitemstring:
	.text "Next Page"
itemoffset:
	.dw 0

blinkselect: ;Requires uplimit as c, downlimit as b, increment as d, and a as starting x-pos
	ld (tempvar1), a
	ld a, d
	ld (increment), a
	ld (uplimit), bc
	ld a, b
	ld (tempvar2), a
ynloop:
	ld hl, selector
	ld de, (tempvar1)
	call drawstring
	ld b, 60	
	call keyloop
	ld de, (tempvar1)
	ld hl, space
	call drawstring
	ld a, (keyvar)
	cp 0
	jr nz, ynwindowloop2
	ld b, 60
	call keyloop
	ld a, (keyvar)
	cp 0
	jr nz, ynwindowloop2
	jr ynloop
ynwindowloop2:
	ld a, (increment)
	ld b, a
	ld a, (keyvar)
	cp 1
	jr z, yndown
	cp 4
	jr z, ynup
	cp 6
	jr z, sendbackans
	cp 9
	jr z, exitpress
	jr ynloop
ynup:
	ld a, (downlimit)
	ld c, a
	ld a, (tempvar2)
	cp c
	jr z, ynloop
	sub b
	ld (tempvar2), a
	jr ynloop
yndown:
	ld a, (uplimit)
	ld c, a
	ld a, (tempvar2)
	cp c
	jr z, ynloop
	add a, b
	ld (tempvar2), a
	jr ynloop
sendbackans:
	call waitkey
	ld a, (downlimit)				;custom menu item select return routine. returns a=(selection y-downlimit)/increment. get it?
	ld b, a
	ld a, (tempvar2)
	sub b
	ld l, a
	ld h, 0
	ld a, (increment)
	call _divHLbyA
	ld a, l
	ret
exitpress:
	call waitkey
	ld a, 255
	ret
uplimit:
	.db 0
downlimit:
	.db 0
increment:
	.db 0
selector:
	.db 208, 0

hlde:
	ld a, h
	cp d
	jr z, nexthlde
	jr nc, biggerhl
lesserhl:
	xor a
	ret
nexthlde
	ld a, l
	cp e
	jr z, samehl
	jr c, lesserhl
biggerhl:
	ld a, 1
	ret
samehl:
	ld a, 2
	ret


nofile:
	call CloseGrey
	ld hl, (findfile)
	inc hl
	inc hl
	ld de, $1c20
	call drawstring
	ld hl, nofilestring
	ld de, $2320
	call drawstring
	call pause
	jp _jforcecmdnochar

ClearScreen:
    ld hl,$fc00               
    ld (hl),l
    ld de,$fc01
    ld bc,1023
    ldir
    ld hl,$fc00              
    ld de,$ca00
    ld bc,1023
    ldir
    ret

pause:
	call waitkey
pause3:
	ld a, %00111111
	out (1), a
	nop
	nop
	in a, (1)
	and %00100000
	jr z, pause2
	jr pause3

pause2:													;waits untils 2nd key is let go
	jp waitkey

keyloop:
	xor a												;most of games processing goes here, because it doubles as a null loop
	ld (keyvar), a
	ld (keycounter), a

keyloopb:
	ld c, b
	ld a, (timercounter1)
	inc a
	cp 82
	call z, nexttimer
	ld (timercounter1), a
	ld b, 50
keyloop2:
 	ld a,%1111110
	out (1),a
 	nop
 	in a,(1)
	ld e, 1
 	rra
 	call nc,ldkey
	inc e
 	rra
 	call nc,ldkey
	inc e
 	rra
 	call nc,ldkey
	inc e
 	rra
 	call nc,ldkey
	inc e
	ld a,%00111111
	out (1), a
	nop
	in a, (1)
	and %01000000
	call z, ldkey
	inc e
	in a, (1)
	ld h, a
	and %00100000
	call z, ldkey
	inc e
	ld a,%01111101
	out (1), a
	nop
	in a, (1)
	ld l, a
	and %00000010
	call z, ldkey
	inc e
	ld a, l
	and %00000100
	call z, ldkey
	inc e
	ld a,%01011111
	out (1), a
	nop
	in a,(1)
	and %10000000
	call z, ldkey
	inc e
	ld a, h
	and %10000000
	call z, ldkey
	djnz keyloop2
	ld b, c
	djnz keyloopb
	ld a, (keyvar)
	ret

ldkey:
	ld d, a
	ld a, e
	ld (keyvar), a
	ld a, (keycounter)
	cp 30
	jr z, staykey
	inc a
	ld (keycounter), a
	ld a, 0
	ld (keyvar), a
staykey:
	ld a, d
	ret

nexttimer:
	ld a, (timercounter2)
	inc a
	cp 79
	call z, addminute
	ld (timercounter2), a
	xor a
	ret

addminute:
	ld hl, (steps)
	inc hl
	ld a, l
	cp 60
	call z, addhour
	ld (steps), hl
	xor a
	ret
addhour:
	ld hl, (hours)
	inc hl
	ld (hours), hl	
	ld hl, 0
	ret
timercounter1:
	.db 0
timercounter2:
	.db 0

; keys:
; 1=down
; 2=left
; 3=right
; 4=up
; 5=exit
; 6=2nd
; 7=plus
; 8=minus
; 9=alpha
;10=more
keycounter:
	.db 0

makewindow:
; b=left
; c=right
; d=bottom
; e=top
	ld (tempword3), bc
	ld (tempword2), de
	ld a, e
	sub d
	inc a
	ld b, a
mwindowloop:
	push bc
	ld bc, (tempword3)
	ld e, b
	ld a, c
	sub b
	inc a
	ld b, a
mwindowloop2:
	push bc
	ld bc, (tempword3)
	ld hl, tempvar1
	xor a
	ld (hl), a
	ld a, e
	cp b
	jr nz, notonleftborder
	ld b, 2
	ld (hl), b
notonleftborder:
	cp c
	jr nz, notonrightborder
	ld a, 4
	ld (hl), a
notonrightborder:
	ld bc, (tempword2)
	ld a, d
	cp b
	jr nz, notontopborder
	ld b, (hl)
	inc b
	ld (hl), b
notontopborder:
	cp c
	jr nz, notonbottomborder
onbottomborder:
	ld a, (hl)
	add a, 6
	cp 10
	jr nz, savewloop
	ld a, 7
savewloop:
	ld (hl), a
notonbottomborder:
	push de
	push de
	ld a, (hl)
	rlca
	rlca
	rlca
	rlca
	ld l, a
	ld h, 0
	ld de, emptysprite
	add hl, de
	pop de
	call GridPutSprite
	pop de
	inc e
	pop bc
	djnz mwindowloop2
	inc d
	pop bc
	djnz mwindowloop
	ret
	
drawstring:														;simple memory solutions
	ld (_penCol), de
	jp _vputs
; The following was borrowed (and modified to display 'cleaner' numbers) from Jezzball
; thx to Magnus Svedin :)
freakynumber2:
	ld a, l
	cp 232 
	jr nc, drawnumber2
	ld a, c
	add a, 4
	ld c, a
	dec d
	jr drawnumber2

freakynumber:
	ld a, l
	cp $10
	jr nc, drawnumber2
	ld a, c
	add a, 4
	ld c, a
	dec d
	jr drawnumber2

drawnumber:
	ld d, 5									;5 digits
	ld a, h	
	cp 39									;if number is between 9984 and 10240, call special routine
	jr z, freakynumber
	jr nc, drawnumber2
	dec d									;4 digits
	ld a, c
	add a, 4								;add 4 to starting coordinates of number (one digit less)
	ld c, a
	ld a, h
	cp 3									;if number is between 768 and 1024, call special routine
	jr z, freakynumber2
	jr nc, drawnumber2
	ld a, c
	add a, 4
	ld c, a
	ld a, l
	dec d									;3 digits
	cp 100
	jr nc, drawnumber2
	ld a, h									;if number is between 256 and 768, it is 3 digits
	cp 0
	jr nz, drawnumber2
	ld a, c
	add a, 4
	ld c, a
	ld a, l
	dec d									;2 digits
	cp 10 
	jr nc, drawnumber2
	ld a, c
	add a, 4
	ld c, a
	dec d									;1 digit
	
drawnumber2:
	ld (_penCol), bc
	ld b, d								;number of digits
	push de
	ld de, numberbuffer+4   ;buffer to store ASCII in
PNStl1:
  call _divHLby10   ;call function to convert from number to digit
  add a, '0'          ;convert digit to ASCII-number for digit
  ld (de), a          ;store in ASCII-buffer
  dec de
  djnz PNStl1         ;loop 5 times
  ld hl, numberbuffer
	pop de
	ld b, d
	ld a, 5
	sub b
	ld d, 0
	ld e, a
	add hl, de
  jp _vputsn   	;print it to screen

; compares locations for characters, chests, and transports
; cpword=location to check for
; b=0 if nothing
cplocation:
	ld hl, (mapsize)
	ld de, (mappos)
	add hl, de
	ld b, (hl)
	inc hl
cplloop:
	push hl
	ld e, (hl)
	inc hl
	ld d, (hl)
	ld hl, (cpword)
	ld a, d
	cp h
	jr nz, cpl4
	ld a, e
	cp l
	jr z, cpl2
cpl4:
	pop hl
	ld de, 6
	add hl, de
	djnz cplloop
	ret
cpl2:
	pop hl
	inc hl
	inc hl				;after cplocation, b<>0 and hl points to first byte of appropriate data (not the cpword)
	ret
cpl3:
	ld b, 0
	ret

;generally quick and easy routines :)

contrastup:
	ld a, ($C008)
	inc a
	ld ($C008), a
	out (2), a
	ret

contrastdown:
	ld a, ($c008)
	dec a
	ld ($C008), a
	out (2), a
	ret

waitkey:
	ld b, 1
	call keyloop
	cp 0
	jr nz, waitkey
	ret

tempword3:
	.dw 0

.end